/***************************************************************************
                          analyticestimator.h  -  description
                             -------------------
    begin                : Thu Jul 28 2005
    copyright            : (C) 2005 by Michael Rosskopf
    email                : rosskopf@cs.uni-duesseldorf.de
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

/*  Description:
For some models it is possible to estimate parameters analytically.
This class implements the corresponding equations.
*/

#ifndef ANALYTICESTIMATOR_H
#define ANALYTICESTIMATOR_H

#include "programparameters.h"
#include "modelparameters.h"
#include "distributionmeasures.h"

/**
  *@author Michael Rosskopf
  */

class AnalyticEstimator {

  public: 

  // Constructors and destructors
  AnalyticEstimator();
  ~AnalyticEstimator();

  // getEstimate: Returns the result of the previous parameter estimation
  ModelParameters* getEstimate();

  // calculateEstimate: Estimates the model parameters analytically
  //                     (only available for the M-normal and the M-extreme model)
  void calculateEstimate(ProgramParameters*,DistributionMeasures*);

  private:

  ModelParameters* estimate; // Stores the result of an analytic parameter estimation

};

#endif
