/***************************************************************************
                          distributionmeasures.cpp  -  description
                             -------------------
    begin                : Mon Feb 16 2004
    copyright            : (C) 2004 by Michael Rosskopf
    email                : rosskopf@cs.uni-duesseldorf.de
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#include "distributionmeasures.h"

// Constructors and destructors:
DistributionMeasures::DistributionMeasures(){
  varianceWithin1 = 0.0;
  varianceWithin2 = 0.0;
  varianceWithin3 = 0.0;
  variance12 = 0.0;
  variance13 = 0.0;
  variance23 = 0.0;
  skewness12 = 0.0;
  skewness13 = 0.0;
  skewness23 = 0.0;
  kurtosis12 = 0.0;
  kurtosis13 = 0.0;
  kurtosis23 = 0.0;
  s1iSkew = 0.0;
  s2iSkew = 0.0;
  s1iPearsonsSkew = 0.0;
  s2iPearsonsSkew = 0.0;
  overallS1iCounter = 0;
  overallS2iCounter = 0;
  side = 0;
  mirrored = 0;
}
DistributionMeasures::~DistributionMeasures(){
}

// get- and set-methods
double DistributionMeasures::getVarianceWithin1(){
  return varianceWithin1;
}
double DistributionMeasures::getVarianceWithin2(){
  return varianceWithin2;
}
double DistributionMeasures::getVarianceWithin3(){
  return varianceWithin3;
}
double DistributionMeasures::getVariance12(){
  return variance12;
}
double DistributionMeasures::getVariance13(){
  return variance13;
}
double DistributionMeasures::getVariance23(){
  return variance23;
}
double DistributionMeasures::getSkewness12(){
  return skewness12;
}
double DistributionMeasures::getSkewness13(){
  return skewness13;
}
double DistributionMeasures::getSkewness23(){
  return skewness23;
}
double DistributionMeasures::getKurtosis12(){
  return kurtosis12;
}
double DistributionMeasures::getKurtosis13(){
  return kurtosis13;
}
double DistributionMeasures::getKurtosis23(){
  return kurtosis23;
}
double DistributionMeasures::getS1iSkew(){
  return s1iSkew;
}
double DistributionMeasures::getS2iSkew(){
  return s2iSkew;
}
double DistributionMeasures::getS1iPearsonsSkew(){
  return s1iPearsonsSkew;
}
double DistributionMeasures::getS2iPearsonsSkew(){
  return s2iPearsonsSkew;
}
long DistributionMeasures::getOverallS1iCounter(){
  return overallS1iCounter;
}
long DistributionMeasures::getOverallS2iCounter(){
  return overallS2iCounter;
}
int DistributionMeasures::getSide(){
  return side;
}
int DistributionMeasures::getMirrored(){
  return mirrored;
}
void DistributionMeasures::setVarianceWithin1(double _varianceWithin1){
  varianceWithin1 = _varianceWithin1;
}
void DistributionMeasures::setVarianceWithin2(double _varianceWithin2){
  varianceWithin2 = _varianceWithin2;
}
void DistributionMeasures::setVarianceWithin3(double _varianceWithin3){
  varianceWithin3 = _varianceWithin3;
}
void DistributionMeasures::setVariance12(double _variance12){
  variance12 = _variance12;
}
void DistributionMeasures::setVariance13(double _variance13){
  variance13 = _variance13;
}
void DistributionMeasures::setVariance23(double _variance23){
  variance23 = _variance23;
}
void DistributionMeasures::setSkewness12(double _skewness12){
  skewness12 = _skewness12;
}
void DistributionMeasures::setSkewness13(double _skewness13){
  skewness13 = _skewness13;
}
void DistributionMeasures::setSkewness23(double _skewness23){
  skewness23 = _skewness23;
}
void DistributionMeasures::setKurtosis12(double _kurtosis12){
  kurtosis12 = _kurtosis12;
}
void DistributionMeasures::setKurtosis13(double _kurtosis13){
  kurtosis13 = _kurtosis13;
}
void DistributionMeasures::setKurtosis23(double _kurtosis23){
  kurtosis23 = _kurtosis23;
}
void DistributionMeasures::setS1iSkew(double _s1iSkew){
  s1iSkew = _s1iSkew;
}
void DistributionMeasures::setS2iSkew(double _s2iSkew){
  s2iSkew = _s2iSkew;
}
void DistributionMeasures::setS1iPearsonsSkew(double _s1iPearsonsSkew){
  s1iPearsonsSkew = _s1iPearsonsSkew;
}
void DistributionMeasures::setS2iPearsonsSkew(double _s2iPearsonsSkew){
  s2iPearsonsSkew = _s2iPearsonsSkew;
}
void DistributionMeasures::setOverallS1iCounter(long _overallS1iCounter){
  overallS1iCounter = _overallS1iCounter;
}
void DistributionMeasures::setOverallS2iCounter(long _overallS2iCounter){
  overallS2iCounter = _overallS2iCounter;
}
void DistributionMeasures::setSide(int _side){
  side = _side;
}
void DistributionMeasures::setMirrored(int _mirrored){
  mirrored = _mirrored;
}

// toString
void DistributionMeasures::toString(ProgramParameters* programParameters){
  cout << "\nSample:         " << programParameters->getSample1() << "\t" << programParameters->getSample2();
  if(programParameters->getSample3() != 0) cout << "\t" << programParameters->getSample3();
  cout << "\nVarianceWithin: " << varianceWithin1 << "\t" << varianceWithin2;
  if(programParameters->getSample3() != 0) cout << "\t" << varianceWithin3;
  cout << "\n\nComparison:     " << programParameters->getSample1() << " - " << programParameters->getSample2();
  if(programParameters->getSample3() != 0) cout << "\t" << programParameters->getSample1() << " - " << programParameters->getSample3() << "\t" << programParameters->getSample2() << " - " << programParameters->getSample3();
  cout << "\nVariance:       " << variance12;
  if(programParameters->getSample3() != 0) cout << "\t" << variance13 << "\t" << variance23;
  cout << "\nSkewness:       " << skewness12;
  if(programParameters->getSample3() != 0) cout << "\t" << skewness13 << "\t" << skewness23;
  cout << "\nKurtosis:       " << kurtosis12;
  if(programParameters->getSample3() != 0) cout << "\t" << kurtosis13 << "\t" << kurtosis23;
  if(programParameters->getMED() == 3){
    cout << "\n\nNumber of S1i-genes:    " << overallS1iCounter << endl;
    cout << "Number of S2i-genes:    " << overallS2iCounter << endl;
    cout << "S1i-Pearsons-Skew:      " << s1iPearsonsSkew << endl;
    cout << "S2i-Pearsons-Skew:      " << s2iPearsonsSkew << endl;
    if(mirrored == 0) cout << "Positive skewed mutation effects" << endl;
    if(mirrored == 1) cout << "Negative skewed mutation effects" << endl;
    if(mirrored == 2) cout << "Positive AND negative mutation effects" << endl;
  } else {
    cout << "\n";
  }
}
