/***************************************************************************
 *   Copyright (C) 2007 by Michael Rosskopf                                *
 *   rosskopf@cs.uni-duesseldorf.de                                        *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
 ***************************************************************************/


#ifdef HAVE_CONFIG_H
#include <config.h>
#endif

#include <iostream>
#include <cstdlib>

#include "controller.h"

using namespace std;

int main(int argc, char *argv[])
{
  cout << "\nE M O G E E   V 1.0 (2007)" << endl;
  cout << "\n(E)stimator for (M)odels (O)f (G)ene (E)xpression (E)volution" << endl;
  cout << "\nBy Michael Rosskopf, University of Duesseldorf, Germany" << endl;
  cout << endl;

  // Dealing with arguments
  char* outputFile; // First argument: specification of the output file
  char* configFile; // Second argument: Specification of the config file
  double rndModifier; // Argument for modifying system time criterion for
                    // initializing the random number generator
                    // (Important for parallel jobs)
  if(argc == 1){
    outputFile = "_output_emogee.txt"; // Standard name for output file, if argument is empty
    rndModifier = 1;                // Standard modfier
    configFile = "config.txt";      // Standard name for config file, if argument is empty
  }
  if(argc == 2){
    outputFile = argv[1];
    rndModifier = 1;                // Standard modifier
    configFile = "config.txt";      // Standard name for config file, if argument is empty
  }
  if(argc == 3){
    outputFile = argv[1];
    rndModifier = atof(argv[2]);
    configFile = "config.txt";      // Standard name for config file, if argument is empty
  }
  if(argc == 4){
    outputFile = argv[1];
    rndModifier = atof(argv[2]);
    configFile = argv[3];
  }

  // The controller contains the main program
  // Every method is called directly or indirectly by the constructor
  Controller controller = Controller(outputFile,configFile,rndModifier);

  // The destructor is called when the program is completed
  controller.~Controller();

  cout << "\nFully machined!\n" << endl;

  return EXIT_SUCCESS;
}
