/***************************************************************************
                          graphictools.h  -  description
                             -------------------
    begin                : Wed Dec 1 2004
    copyright            : (C) 2004 by Michael Rosskopf
    email                : rosskopf@cs.uni-duesseldorf.de
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

/*  Description:
This class contains tools for binning of distributions which can be used,
for example, for visualization of data.
*/

#ifndef GRAPHICTOOLS_H
#define GRAPHICTOOLS_H

#include <iostream.h>
#include <fstream.h>

/**
  *@author Michael Rosskopf
  */

class GraphicTools {

public: 

  // Constructors and destructors
  GraphicTools();
  ~GraphicTools();

  // drawHistogram: Different methods to draw a histogram from data
  void drawHistogram(double[],long);
  void drawHistogram(double[],long,long);
  void drawHistogram(double[],long,long,double,double);
  void drawHistogramWithTruncation(double[],long,long,double,double);

  // calcHistogramPlot: Different methods to bin data, but without visualisation
  void calcHistogramPlot(double[],long,double[],long,double,double);
  void calcHistogramPlot(double[],long,double[],long,double*,double*);
  void calcHistogramPlotWithTruncation(double[],long,double[],long,double,double);
};

#endif
