/***************************************************************************
 *   Copyright (C) 2007 by Michael Rosskopf                                *
 *   rosskopf@cs.uni-duesseldorf.de                                        *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
 ***************************************************************************/

#include "programparameters.h"

// Constructors and destructors
ProgramParameters::ProgramParameters(char* outputFile, char* configFile){

  // Parameters defined by the config-file
  char charbuffer;
  char stringbuffer[4096];
  ifstream file(configFile);

  file.get(stringbuffer,4096,'=');
  do{file.get(charbuffer); charbuffer = file.peek();} while(charbuffer == ' '); 
  file.get(stringbuffer,4096,';');
  mode = atof(stringbuffer);

  file.get(stringbuffer,4096,'=');
  do{file.get(charbuffer); charbuffer = file.peek();} while(charbuffer == ' '); 
  file.get(stringbuffer,4096,';');
  modelParameterFilename = new char[sizeof(stringbuffer)];
  strcpy(modelParameterFilename,stringbuffer);

  file.get(stringbuffer,4096,'=');
  do{file.get(charbuffer); charbuffer = file.peek();} while(charbuffer == ' '); 
  file.get(stringbuffer,4096,';');
  dataTableFilename = new char[sizeof(stringbuffer)];
  strcpy(dataTableFilename,stringbuffer);

  file.get(stringbuffer,4096,'=');
  do{file.get(charbuffer); charbuffer = file.peek();} while(charbuffer == ' '); 
  file.get(stringbuffer,4096,';');
  sample1 = atof(stringbuffer);

  file.get(stringbuffer,4096,'=');
  do{file.get(charbuffer); charbuffer = file.peek();} while(charbuffer == ' '); 
  file.get(stringbuffer,4096,';');
  sample2 = atof(stringbuffer);

  file.get(stringbuffer,4096,'=');
  do{file.get(charbuffer); charbuffer = file.peek();} while(charbuffer == ' '); 
  file.get(stringbuffer,4096,';');
  sample3 = atof(stringbuffer);

  file.get(stringbuffer,4096,'=');
  do{file.get(charbuffer); charbuffer = file.peek();} while(charbuffer == ' '); 
  file.get(stringbuffer,4096,';');
  analysisType = atof(stringbuffer);

  file.get(stringbuffer,4096,'=');
  do{file.get(charbuffer); charbuffer = file.peek();} while(charbuffer == ' '); 
  file.get(stringbuffer,4096,';');
  numberOfGenes = atof(stringbuffer);

  file.get(stringbuffer,4096,'=');
  do{file.get(charbuffer); charbuffer = file.peek();} while(charbuffer == ' '); 
  file.get(stringbuffer,4096,';');
  numberOfSimulations = atof(stringbuffer);

  file.get(stringbuffer,4096,'=');
  do{file.get(charbuffer); charbuffer = file.peek();} while(charbuffer == ' '); 
  file.get(stringbuffer,4096,';');
  numberOfRuns = atof(stringbuffer);

  file.get(stringbuffer,4096,'=');
  do{file.get(charbuffer); charbuffer = file.peek();} while(charbuffer == ' '); 
  file.get(stringbuffer,4096,';');
  mED = atof(stringbuffer);

  file.get(stringbuffer,4096,'=');
  do{file.get(charbuffer); charbuffer = file.peek();} while(charbuffer == ' '); 
  file.get(stringbuffer,4096,';');
  quality = atof(stringbuffer);

  file.get(stringbuffer,4096,'=');
  do{file.get(charbuffer); charbuffer = file.peek();} while(charbuffer == ' '); 
  file.get(stringbuffer,4096,';');
  outputPrecision = atof(stringbuffer);

  file.get(stringbuffer,4096,'=');
  do{file.get(charbuffer); charbuffer = file.peek();} while(charbuffer == ' '); 
  file.get(stringbuffer,4096,';');
  standardLowerBoundAlpha = atof(stringbuffer);

  file.get(stringbuffer,4096,'=');
  do{file.get(charbuffer); charbuffer = file.peek();} while(charbuffer == ' '); 
  file.get(stringbuffer,4096,';');
  minimalAlpha = atof(stringbuffer);

  file.get(stringbuffer,4096,'=');
  do{file.get(charbuffer); charbuffer = file.peek();} while(charbuffer == ' '); 
  file.get(stringbuffer,4096,';');
  standardUpperBoundAlpha = atof(stringbuffer);

  file.get(stringbuffer,4096,'=');
  do{file.get(charbuffer); charbuffer = file.peek();} while(charbuffer == ' '); 
  file.get(stringbuffer,4096,';');
  maximalAlpha = atof(stringbuffer);

  file.get(stringbuffer,4096,'=');
  do{file.get(charbuffer); charbuffer = file.peek();} while(charbuffer == ' '); 
  file.get(stringbuffer,4096,';');
  nonMutationalEffects = atof(stringbuffer);

  file.get(stringbuffer,4096,'=');
  do{file.get(charbuffer); charbuffer = file.peek();} while(charbuffer == ' '); 
  file.get(stringbuffer,4096,';');
  method = atof(stringbuffer);

  file.get(stringbuffer,4096,'=');
  do{file.get(charbuffer); charbuffer = file.peek();} while(charbuffer == ' '); 
  file.get(stringbuffer,4096,';');
  numberOfBins = atof(stringbuffer);

  file.get(stringbuffer,4096,'=');
  do{file.get(charbuffer); charbuffer = file.peek();} while(charbuffer == ' '); 
  file.get(stringbuffer,4096,';');
  maximalD = atof(stringbuffer);

  file.get(stringbuffer,4096,'=');
  do{file.get(charbuffer); charbuffer = file.peek();} while(charbuffer == ' '); 
  file.get(stringbuffer,4096,';');
  repeats = atof(stringbuffer);

  file.get(stringbuffer,4096,'=');
  do{file.get(charbuffer); charbuffer = file.peek();} while(charbuffer == ' '); 
  file.get(stringbuffer,4096,';');
  sigmaMLo = atof(stringbuffer);

  file.get(stringbuffer,4096,'=');
  do{file.get(charbuffer); charbuffer = file.peek();} while(charbuffer == ' '); 
  file.get(stringbuffer,4096,';');
  sigmaMHi = atof(stringbuffer);

  file.get(stringbuffer,4096,'=');
  do{file.get(charbuffer); charbuffer = file.peek();} while(charbuffer == ' '); 
  file.get(stringbuffer,4096,';');
  sigmaELo = atof(stringbuffer);

  file.get(stringbuffer,4096,'=');
  do{file.get(charbuffer); charbuffer = file.peek();} while(charbuffer == ' '); 
  file.get(stringbuffer,4096,';');
  sigmaEHi = atof(stringbuffer);

  file.get(stringbuffer,4096,'=');
  do{file.get(charbuffer); charbuffer = file.peek();} while(charbuffer == ' '); 
  file.get(stringbuffer,4096,';');
  dLo = atof(stringbuffer);

  file.get(stringbuffer,4096,'=');
  do{file.get(charbuffer); charbuffer = file.peek();} while(charbuffer == ' '); 
  file.get(stringbuffer,4096,';');
  dHi = atof(stringbuffer);

  file.close();

  // Hard coded parameters
  outputMode = 2;
  skewType = 2;
  numberOfSets = 2;

  cout << "Parameters:\n" << endl;
  cout << "Config-File:          " << configFile << endl;
  cout << "Output-File:          " << outputFile << endl;
  cout << "Model-Parameter-File: " << modelParameterFilename << endl;
  cout << "Data-File:            " << dataTableFilename << endl;
  if(mode == 1) cout << "\nMode:     DATA GENERATION" << endl;
  if(mode == 2) cout << "\nMode:     ESTIMATION ON REAL DATA" << endl;
  if(mode == 3) cout << "\nMode:     ESTIMATION ON BOOTSTRAP DATA" << endl;
  if(mode == 4) cout << "\nMode:     ESTIMATION ON GENERATED DATA" << endl;
  if(mode == 2 || mode ==3){
    if(sample3 == 0){
      cout << "Samples:  Sample 1: " << sample1 << "   Sample 2: " << sample2 << "   Sample 3: -" << endl;
    } else {
      cout << "Samples:  Sample 1: " << sample1 << "   Sample 2: " << sample2 << "   Sample 3: " << sample3 << endl;
    }
    if(analysisType == 1) cout << "Analysis Type: MEAN OF ALL PAIRWISE COMPARISONS" << endl;
    if(analysisType == 2) cout << "Analysis Type: ESTIMATION FOR ALL PAIRS" << endl;
  }
  cout << "\nNumber of genes:        " << numberOfGenes << endl;
  cout << "Number of simulations:  " << numberOfSimulations << endl;
  cout << "Number of runs:         " << numberOfRuns << endl;
  if(mED == 1) cout << "\nMutation effect distribution:    NORMAL" << endl;
  if(mED == 2) cout << "\nMutation effect distribution:    EXTREME VALUE" << endl;
  if(mED == 3) cout << "\nMutation effect distribution:    GAMMA" << endl;
  if(nonMutationalEffects == 1) cout << "Modelling non-mutational effect: NO" << endl;
  if(nonMutationalEffects == 2) cout << "Modelling non-mutational effect: YES" << endl;
  if(nonMutationalEffects == 2){
    if(method == 1) cout << "Estimation method:               Chi^2" << endl;
    if(method == 2) cout << "Estimation method:               Maximum Likelihood" << endl;
  } else {
    if(mED == 3){
      cout << "Estimation method:               Root find" << endl;
    } else {
      cout << "Estimation method:               Analytic" << endl;
    }
  }
  cout << "\nQuality:                    " << quality << endl;
  cout << "\nMax. overall branch length: " << maximalD << endl;
  cout << "\n----------------------------------------------------------------" << endl;
  cout << "----------------------------------------------------------------" << endl;
}
ProgramParameters::~ProgramParameters(){
}

// get-methods
int ProgramParameters::getMode(){
  return mode;
}
char* ProgramParameters::getModelParameterFilename(){
  return modelParameterFilename;
}
char* ProgramParameters::getDataTableFilename(){
  return dataTableFilename;
}
int ProgramParameters::getSample1(){
  return sample1;
}
int ProgramParameters::getSample2(){
  return sample2;
}
int ProgramParameters::getSample3(){
  return sample3;
}
int ProgramParameters::getAnalysisType(){
  return analysisType;
}
long ProgramParameters::getNumberOfGenes(){
  return numberOfGenes;
}
long ProgramParameters::getNumberOfSimulations(){
  return numberOfSimulations;
}
long ProgramParameters::getNumberOfRuns(){
  return numberOfRuns;
}
int ProgramParameters::getMED(){
  return mED;
}
double ProgramParameters::getQuality(){
  return quality;
}
int ProgramParameters::getOutputPrecision(){
  return outputPrecision;
}
int ProgramParameters::getOutputMode(){
  return outputMode;
}
double ProgramParameters::getStandardLowerBoundAlpha(){
  return standardLowerBoundAlpha;
}
double ProgramParameters::getMinimalAlpha(){
  return minimalAlpha;
}
double ProgramParameters::getStandardUpperBoundAlpha(){
  return standardUpperBoundAlpha;
}
double ProgramParameters::getMaximalAlpha(){
  return maximalAlpha;
}
int ProgramParameters::getSkewType(){
  return skewType;
}
int ProgramParameters::getNumberOfSets(){
  return numberOfSets;
}
int ProgramParameters::getNonMutationalEffects(){
  return nonMutationalEffects;
}
int ProgramParameters::getMethod(){
  return method;
}
int ProgramParameters::getNumberOfBins(){
  return numberOfBins;
}
double ProgramParameters::getMaximalD(){
  return maximalD;
}
int ProgramParameters::getRepeats(){
  return repeats;
}
double ProgramParameters::getSigmaMLo(){
  return sigmaMLo;
}
double ProgramParameters::getSigmaMHi(){
  return sigmaMHi;
}
double ProgramParameters::getSigmaELo(){
  return sigmaELo;
}
double ProgramParameters::getSigmaEHi(){
  return sigmaEHi;
}
double ProgramParameters::getDLo(){
  return dLo;
}
double ProgramParameters::getDHi(){
  return dHi;
}

// set-methods
void ProgramParameters::setMode(int _mode){
  mode = _mode;
}
void ProgramParameters::setModelParameterFilename(char* _modelParameterFilename){
  int i = sizeof(_modelParameterFilename);
  modelParameterFilename = new char[i];
  strcpy(modelParameterFilename,_modelParameterFilename);
}
void ProgramParameters::setDataTableFilename(char* _dataTableFilename){
  int i = sizeof(_dataTableFilename);
  dataTableFilename = new char[i];
  strcpy(dataTableFilename,_dataTableFilename);
}
void ProgramParameters::setSample1(int _sample1){
  sample1 = _sample1;
}
void ProgramParameters::setSample2(int _sample2){
  sample2 = _sample2;
}
void ProgramParameters::setSample3(int _sample3){
  sample3 = _sample3;
}
void ProgramParameters::setAnalysisType(int _analysisType){
  analysisType = _analysisType;
}
void ProgramParameters::setNumberOfGenes(long _numberOfGenes){
  numberOfGenes = _numberOfGenes;
}
void ProgramParameters::setNumberOfSimulations(long _numberOfSimulations){
  numberOfSimulations = _numberOfSimulations;
}
void ProgramParameters::setMED(int _mED){
  mED = _mED;
}
void ProgramParameters::setMethod(int _method){
  method = _method;
}
void ProgramParameters::setRepeats(int _repeats){
  repeats = _repeats;
}
void ProgramParameters::setSigmaMLo(double _sigmaMLo){
  sigmaMLo = _sigmaMLo;
}
void ProgramParameters::setSigmaMHi(double _sigmaMHi){
  sigmaMHi = _sigmaMHi;
}
void ProgramParameters::setSigmaELo(double _sigmaELo){
  sigmaELo = _sigmaELo;
}
void ProgramParameters::setSigmaEHi(double _sigmaEHi){
  sigmaEHi = _sigmaEHi;
}
void ProgramParameters::setDLo(double _dLo){
  dLo = _dLo;
}
void ProgramParameters::setDHi(double _dHi){
  dHi = _dHi;
}
void ProgramParameters::setSkewType(int _skewType){
  skewType = _skewType;
}
void ProgramParameters::setNumberOfSets(int _numberOfSets){
  numberOfSets = _numberOfSets;
}
void ProgramParameters::setStandardLowerBoundAlpha(double _standardLowerBoundAlpha){
  standardLowerBoundAlpha = _standardLowerBoundAlpha;
}
void ProgramParameters::setMinimalAlpha(double _minimalAlpha){
  minimalAlpha = _minimalAlpha;
}
void ProgramParameters::setStandardUpperBoundAlpha(double _standardUpperBoundAlpha){
  standardUpperBoundAlpha = _standardUpperBoundAlpha;
}
void ProgramParameters::setMaximalAlpha(double _maximalAlpha){
  maximalAlpha = _maximalAlpha;
}
void ProgramParameters::setNonMutationalEffects(int _nonMutationalEffects){
  nonMutationalEffects = _nonMutationalEffects;
}
void ProgramParameters::setNumberOfBins(int _numberOfBins){
  numberOfBins = _numberOfBins;
}
void ProgramParameters::setMaximalD(double _maximalD){
  maximalD = _maximalD;
}
void ProgramParameters::setQuality(double _quality){
  quality = _quality;
}
void ProgramParameters::setNumberOfRuns(long _numberOfRuns){
  numberOfRuns = _numberOfRuns;
}
void ProgramParameters::setOutputMode(int _outputMode){
  outputMode = _outputMode;
}
void ProgramParameters::setOutputPrecision(int _outputPrecision){
  outputPrecision = _outputPrecision;
}

// toString:
void ProgramParameters::toString(){
  cout << "mode = " << mode << endl;
  cout << "modelParameterFilename = " << modelParameterFilename << endl;
  cout << "dataTableFilename = " << dataTableFilename << endl;
  cout << "sample1 = " << sample1 << endl;
  cout << "sample2 = " << sample2 << endl;
  cout << "sample3 = " << sample3 << endl;
  cout << "analysisType = " << analysisType << endl;
  cout << "numberOfGenes = " << numberOfGenes << endl;
  cout << "numberOfSimulations = " << numberOfSimulations << endl;
  cout << "numberOfRuns = " << numberOfRuns << endl;
  cout << "mED = " << mED << endl;
  cout << "method = " << method << endl;
  cout << "repeats = " << repeats << endl;
  cout << "sigmaMLo = " << sigmaMLo << endl;
  cout << "sigmaMHi = " << sigmaMHi << endl;
  cout << "sigmaELo = " << sigmaELo << endl;
  cout << "sigmaEHi = " << sigmaEHi << endl;
  cout << "dLo = " << dLo << endl;
  cout << "dHi = " << dHi << endl;
  cout << "skewType  = " << skewType << endl;
  cout << "numberOfSets  = " << numberOfSets << endl;
  cout << "standardLowerBoundAlpha  = " << standardLowerBoundAlpha << endl;
  cout << "minimalAlpha  = " << minimalAlpha << endl;
  cout << "standardUpperBoundAlpha  = " << standardUpperBoundAlpha << endl;
  cout << "maximalAlpha  = " << maximalAlpha << endl;
  cout << "nonMutationalEffects  = " << nonMutationalEffects << endl;
  cout << "numberOfBins = " << numberOfBins << endl;
  cout << "maximalD = " << maximalD << endl;
  cout << "quality = " << quality << endl;
  cout << "outputMode = " << outputMode << endl;
  cout << "outputPrecision = " << outputPrecision << endl;
}

// checkProgramParameters: Returns true if program parameters are valid
bool ProgramParameters::checkProgramParameters(){
 
  bool valid = true;

  if(mode != 1 && mode != 2 && mode != 3 && mode != 4){cout << "\nError: mode " << mode << " not supported." << endl; valid = false;}
  if(sample1 < 1){cout << "\nError: sample1 must be larger than 0." << endl; valid = false;}
  if(sample2 < 1){cout << "\nError: sample2 must be larger than 0." << endl; valid = false;}
  if(sample3 < 0){cout << "\nError: sample3 must be at least 0." << endl; valid = false;}
  if(analysisType != 1 && analysisType != 2){cout << "\nError: analysisType " << analysisType << " not supported." << endl; valid = false;}
  if(numberOfGenes < 1){cout << "\nError: numberOfGenes must be larger than 0." << endl; valid = false;}
  if(numberOfSimulations < 1){cout << "\nError: numberOfSimulations must be larger than 0." << endl; valid = false;}
  if(numberOfRuns < 1){cout << "\nError: numberOfRuns must be larger than 0." << endl; valid = false;}
  if(mED != 1 && mED != 2 && mED != 3){cout << "\nError: mED " << mED << " not supported." << endl; valid = false;}
  if(method != 1 && method != 2){cout << "\nError: method " << method << " not supported." << endl; valid = false;}
  if(repeats < 1){cout << "\nError: repeats must be larger than 0." << endl; valid = false;}
  if(sigmaMLo < 0.0){cout << "\nError: sigmaMLo must be at least 0." << endl; valid = false;}
  if(sigmaMHi < 0.0){cout << "\nError: sigmaMHi must be at least 0." << endl; valid = false;}
  if(sigmaELo < 0.0){cout << "\nError: sigmaELo must be at least 0." << endl; valid = false;}
  if(sigmaEHi < 0.0){cout << "\nError: sigmaEHi must be at least 0." << endl; valid = false;}
  if(dLo < 0.0){cout << "\nError: dLo must be at least 0." << endl; valid = false;}
  if(dHi < 0.0){cout << "\nError: dHi must be at least 0." << endl; valid = false;}
  if(standardLowerBoundAlpha <= 0.0){cout << "\nError: standardLowerBoundAlpha must be larger than 0." << endl; valid = false;}
  if(minimalAlpha <= 0.0){cout << "\nError: minimalAlpha must be larger than 0." << endl; valid = false;}
  if(standardUpperBoundAlpha <= 0.0){cout << "\nError: standardUpperBoundAlpha must be larger than 0." << endl; valid = false;}
  if(maximalAlpha <= 0.0){cout << "\nError: maximalAlpha must be larger than 0." << endl; valid = false;}
  if(nonMutationalEffects != 1 && nonMutationalEffects != 2){cout << "\nError: nonMutationalEffects." << endl; valid = false;}
  if(numberOfBins < 1){cout << "\nError: numberOfBins must be larger than 0." << endl; valid = false;}
  if(maximalD <= 0.0){cout << "\nError: maximalD must be larger than 0." << endl; valid = false;}
  if(quality <= 0.0 || quality > 1.0){cout << "\nError: quality must be between 0 and 1." << endl; valid = false;}
  if(outputPrecision < 1){cout << "\nError: outputPrecision must be larger than 0." << endl; valid = false;}

  // Check critical combinations of program parameters

  // Normal distribution
  if(mED == 1 && nonMutationalEffects == 2 && sample3 != 0){cout << "\nError: No sample3 (outgroup) support for M&E-normal model." << endl; valid = false;}
  // Extreme value distribution
  if(mED == 2 && nonMutationalEffects == 2 && sample3 != 0){cout << "\nError: No sample3 (outgroup) support for M&E-extreme model." << endl; valid = false;}
  // Gamma distribution
  if(mED == 3){
    if(sample3 == 0){cout << "\nError: M-gamma model needs a sample3 (outgroup)." << endl; valid = false;}
    if(nonMutationalEffects == 2){cout << "\nError: M-gamma model does not support non-mutational effects." << endl; valid = false;}
  }
//  Estimation for all pairs is only supported for the mode "ESTIMATION ON REAL DATA"
  if(analysisType == 2 && (sample3 != 0 || mode != 2)){cout << "\nError: analysisType 2 is only supported for mode == 2 and sample3 == 0." << endl; valid = false;}

  // ML only supported for the M&E-normal model
  if(method == 2 && mED != 1 && nonMutationalEffects == 2){cout << "\nError: Maximum likelihood estimation only supported for mED = 1." << endl; valid = false;}

  return valid;
}
