/***************************************************************************
                          random.cpp  -  description
 ***************************************************************************/

/*  Description:
This class implements a special random number generator used to draw random numbers from
a gamma distribution.
*/

#ifndef RANDOM_H
#define RANDOM_H

#define ranDum dkiss
#define starTup start_kiss

#include <math.h>
#include <stdio.h>
#include <stdlib.h>
#include <string.h>

class Random{

  public:

  // Constructors and destructors
  Random();
  ~Random();

  double sexp(void);
  void start_kiss(int seed);
  void restart_kiss(unsigned int *vals);
  void kiss_state(unsigned int *vals);
  unsigned int kiss(void);
  double dkiss(void);
  double normal(void);
  double rgamma(double a, double scale);

  private:

  /******************************************************************/
  /*  variables for the kiss random number generator                */
  /******************************************************************/
  unsigned int k,m,x,y,z,w,carry,r;
  /****************************************************************/
  double a1;
  double a2;
  double a3;
  double a4;
  double a5;
  double a6;
  double a7;
  double e1;
  double e2;
  double e3;
  double e4;
  double e5;
  double q1;
  double q2;
  double q3;
  double q4;
  double q5;
  double q6;
  double q7;
  double sqrt32;
  double aa;
  double aaa;
};
 
#endif



